"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const laravel_mix_1 = __importDefault(require("laravel-mix"));
const Component_1 = require("laravel-mix/src/components/Component");
const DumpWebpackConfig_1 = __importDefault(require("laravel-mix/src/components/DumpWebpackConfig"));
const dumpWebpackConfigComponent = new DumpWebpackConfig_1.default(laravel_mix_1.default);
class WebpackConfig extends Component_1.Component {
    name() {
        return ['getWebpackConfig', 'lwc', 'listenWebpackConfig'];
    }
    register(callback) {
        this.context.listen('configReadyForUser', (config) => {
            callback(config, dumpWebpackConfigComponent.circularStringify);
        });
    }
    mix() {
        const originalDumpRegistrationFunc = this.context.api.dumpWebpackConfig.bind(this.context.api);
        const dumpOverride = (callback) => {
            originalDumpRegistrationFunc();
            if (callback) {
                this.register(callback);
            }
        };
        return {
            dump: dumpOverride,
            dumpWebpackConfig: dumpOverride,
        };
    }
}
laravel_mix_1.default.extend('getWebpackConfig', WebpackConfig);
//# sourceMappingURL=index.js.map